// Cyphesis Online RPG Server and AI Engine
// Copyright (C) 2007 Alistair Riddoch
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software Foundation,
// Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

// $Id: StatusProperty.cpp,v 1.2 2007-12-03 20:40:55 alriddoch Exp $

#include "StatusProperty.h"

#include "Entity.h"

#include <Atlas/Objects/Operation.h>
#include <Atlas/Objects/Anonymous.h>

using Atlas::Message::Element;
using Atlas::Objects::Operation::Delete;
using Atlas::Objects::Entity::Anonymous;

StatusProperty::StatusProperty(Entity * owner) : PropertyBase(0),
                                                 m_owner(owner),
                                                 m_value(1.f)
{
}

bool StatusProperty::get(Element & ent) const
{
    ent = m_value;
    return true;
}

void StatusProperty::set(const Element & ent)
{
    if (ent.isNum()) {
        m_value = ent.asNum();
        if (m_value < 0) {
            Delete del;
            Anonymous delete_arg;
            delete_arg->setId(m_owner->getId());
            del->setArgs1(delete_arg);
            del->setTo(m_owner->getId());
            m_owner->sendWorld(del);
        }
    }
}
